/*
 * iGeom by LInE
 * Free software to student private data
 *
 * http://www.matematica.br/igeom
 * http://www.usp.br/line
 *
 * Create and register new element IntersectionPoint
 * It is used in ./app/core/application/menu.js
 *
 * ./app/component-registry/intersection-component.js
 * @version 2023/09/20: Added new parameter 'description,' to 'ComponentOptions'
 */

import { Component } from "../core/models/components/component";
import { ComponentOptions } from "../core/models/components/component-options";
import { IntersectionDrawer } from "../components/intersection-component/drawers/intersection-drawer";

export class IntersectionComponent extends Component {

  //TODO: it is necessary internationalization!

  constructor () {
    const options = new ComponentOptions(
      "e60c06bc485546fe89f3565e9f8758e7",
      "Intersection",
      "Construct the intersection point of other two Geometric Objects (select those 2 objects)",
      "intersection"
      );
    super(new IntersectionDrawer(), options);
    }
  }

export const intersectionComponent = new IntersectionComponent();