/*
 * iGeom by LInE
 * Free software to student private data
 *
 * http://www.matematica.br/igeom
 * http://www.usp.br/line
 *
 * Create and register new element MidPoint
 * It is used in ./app/core/application/menu.js
 *
 * ./app/component-registry/selector-component.js
 * @version 2023/09/20: Added new parameter 'description,' to 'ComponentOptions'
 */

import { Component } from "../core/models/components/component";
import { ComponentOptions } from "../core/models/components/component-options";
import { SelectorDrawer } from "../components/selector-component/drawers/selector-drawer";
import { COMPONENT_TYPE } from "../core/enums/component-type-enum";

export class SelectorComponent extends Component {

  //TODO: it is necessary internationalization!

  constructor () {
    const options = new ComponentOptions(
      "15d1b49619c946809fdb6922f4d7b657",
      "Selector",
      "With Selector you can mark/select several objects (e.g. to remove all of them with a single 'del')",
      "selector",
      COMPONENT_TYPE.SELECTOR
      );
    super(new SelectorDrawer(), options);
    }

  }

export const selectorComponent = new SelectorComponent();